<?php
/**
*
* @package acp Official Topic Index
* @copyright (c) 2012 Soshen <nipponart.org>
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_oindex
{
	var $u_action;

	function main($id, $mode)
	{
		global $db, $user, $template;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;
		
		$user->add_lang('mods/lang_oindex');
		
		$this->tpl_name		= 'acp_oindex';
		$this->page_title	= 'ACP_OINDEX_CFG';
		$forumari			= array();
		$error				= array();
		$submit				= (isset($_POST['submit'])) ? true : false;
		$setcfg				= (isset($_POST['setcfg'])) ? true : false;
		$delete				= request_var('del', 0);
		
		// Check if the umil file are installed.
		if (empty($config['otindex_version']))
		{
			$redirect_url = append_sid("{$phpbb_admin_path}index.$phpEx");
			meta_refresh(4, $redirect_url);
			trigger_error(sprintf($user->lang['OTINDEX_UMIL_NOT_ACTIVE'], '<a href="' . $redirect_url . '">', '</a>'));
		}
		
		// Check versions
		$errstr		= '';
		$errno		= 0;
		$remotefile	= get_remote_file("nipponart.org", '', 'modversion.txt', $errstr, $errno);
		
		if ($remotefile !== false)
		{
			preg_match('/otindex=(.*?)__/msu', $remotefile, $oitversion);
			if ($config['otindex_version'] != $oitversion[1])
			{
				$error[] = sprintf($user->lang['OTINDEX_MUST_BE_UPDATED'], $config['otindex_version'], $oitversion[1]);
			}
		}

		// Get forums list
		$forum_list = make_forum_select(false, false, true, false, false, false, true);
		
		// Build forum options
		$s_forum_options = '';
		foreach ($forum_list as $f_id => $f_row)
		{
			$s_forum_options .= '<option value="' . $f_id . '"' . (($f_row['disabled'] || $f_row['forum_type'] != 1) ? ' disabled="disabled" class="disabled-option"' : '') . '>' . $f_row['padding'] . $f_row['forum_name'] . '</option>';
		}

		$template->assign_vars(array(
			'S_SELECT_FORUM'		=> true,
			'S_FORUM_OPTIONS'		=> $s_forum_options,
			'U_ACTION'				=> $this->u_action,
			'S_OVERFLOW'			=> (!empty($config['oindex_overflow'])) ? ' checked="checked"' : '',
			'S_FORUM_MULTIPLE'		=> true)
		);
		
		// Get saved lists
		$sql	= 'SELECT * FROM ' . TOPIC_LISTS . ' ORDER BY list_name ASC';
		$result	= $db->sql_query($sql);
		$i		= 0;
		while ($row = $db->sql_fetchrow($result))
		{
			$forumari 	= unserialize($row['list_forum']);
			
			$template->assign_block_vars('list', array(
				'LIST_NAME'		=> $row['list_name'],
				'LIST_FORUMS'	=> (sizeof($forumari)) ? implode(', ', $forumari) : '',
				'U_REMOVE'		=> append_sid("{$phpbb_admin_path}index.$phpEx", "i=oindex&amp;mode=main&amp;del=" . $row['list_id'])
			));
			
			$i++;
		}
		$db->sql_freeresult($result);
		
		$template->assign_vars(array(
			'S_LIST'	=> ($i > 0) ? true : false,
			'ERROR'		=> (sizeof($error)) ? implode('<br />', $error) : '')
		);
		
		/***********
		* ACTIONS
		**/
		
		if ($submit)
		{
			unset($error);
			$error		= array();
			$listname	= utf8_normalize_nfc(request_var('list_name', '', true));
			$forumlist	= request_var('forum_id', array(0));
			
			if (empty($listname))
			{
				$error[] = $user->lang['NAME_FORUM_LIST_EMPTY'];
			}
			
			if (empty($forumlist))
			{
				$error[] = $user->lang['SELECT_FORUM_LIST_EMPTY'];
			}
			
			if (!sizeof($error))
			{
				$sql_array	= array(
					'list_name'		=> $listname,
					'list_forum'	=> serialize($forumlist),
				);
				$sql	= "INSERT INTO " . TOPIC_LISTS . " " . $db->sql_build_array('INSERT', $sql_array);
				$db->sql_query($sql);
				
				add_log('admin', 'LOG_OINDEX_ADDLIST', $user->data['username']);
				trigger_error($user->lang['OINDEX_ADDED_LIST'] . adm_back_link($this->u_action));
			}
			
			$template->assign_vars(array(
				'ERROR'		=> (sizeof($error)) ? implode('<br />', $error) : '')
			);
		}
		
		if (!empty($delete))
		{
			$sql	= "DELETE FROM " . TOPIC_LISTS . " WHERE list_id = " . $delete;
			$db->sql_query($sql);
			
			add_log('admin', 'LOG_OINDEX_DELETELIST', $user->data['username']);
			trigger_error($user->lang['OINDEX_DELETED_LIST'] . adm_back_link($this->u_action));
		}
		
		if ($setcfg)
		{
			$overflow = request_var('overflow', 0);
			set_config('oindex_overflow', $overflow);
			
			add_log('admin', 'LOG_OINDEX_EDITCFG', $user->data['username']);
			trigger_error($user->lang['OINDEX_EDIT_CFG'] . adm_back_link($this->u_action));
		}
	}
}
?>