<?php
/**
*
* @package umil
* @version $Id otopicindex_install.php
* @copyright (c) 2011 Soshen <nipponart.org>
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);

$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}
/*
* The name of the config variable which will hold the currently installed version
* You do not need to set this yourself, UMIL will handle setting and updating the version itself.
*/
$version_config_name = 'otindex_version';

$language_file = 'mods/umil_otindex_install';

// The name of the mod to be displayed during installation.
$mod_name = 'ACP_OFFICIAL_TOPIC_INDEX';

/*
* The array of versions and actions within each.
* You do not need to order it a specific way (it will be sorted automatically), however, you must enter every version, even if no actions are done for it.
*
* You must use correct version numbering.  Unless you know exactly what you can use, only use X.X.X (replacing X with an integer).
* The version numbering must otherwise be compatible with the version_compare function - http://php.net/manual/en/function.version-compare.php
*/
$versions = array(

	// Version 1.0.0
	'1.0.0'	=> array(
		//Add table row
		'table_column_add' => array(
			array("phpbb_topics", 'inindex_topic', array('TINT:1', 0)),
			array("phpbb_topics", 'outindex_topic', array('TINT:1', 0)),
			array("phpbb_forums", 'post_index', array('UINT:10', 0)),
			array("phpbb_forums", 'default_inindex', array('TINT:1', 0))
		),
	), // end of array 1.0.0
	
	// Version 1.0.1
	'1.0.1'	=> array(
		// do nothing
	), // end of array 1.0.1
	
	// Version 2.0.0
	'2.0.0'	=> array(
		//Add table row
		'table_column_add' => array(
			array("phpbb_forums", 'tag_filter', array('TINT:1', 0))
		),
		
		// Add config values
		'config_add' => array(
			array('oindex_overflow', 0)
		),
		
		// Add table
		'table_add' => array(
			array('phpbb_forum_lists', array(
				'COLUMNS'	=> array(
					'list_id'		=> array('UINT', NULL, 'auto_increment'),
					'list_name'		=> array('VCHAR_UNI:255', ''),
					'list_forum'	=> array('TEXT_UNI', ''),
				),
				'PRIMARY_KEY'	=> 'list_id',
				),
			),
		),
		
		//Add module
		'module_add' => array(
			array('acp', 'ACP_CAT_DOT_MODS', 'ACP_CAT_OINDEX'),
			array('acp', 'ACP_CAT_OINDEX',
				array('module_basename'	=> 'oindex'),
			),
		),
		
		//Clear cache
		'cache_purge' => array(''),
	), // end of array 2.0.0
	
	// Version 2.0.1
	'2.0.1'	=> array(
		// do nothing
	), // end of array 2.0.1
);

// Include the UMIF Auto file and everything else will be handled automatically.
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);


?>