<?php
/**
*
* @package Official Topic Index
* @version $Id$
* @copyright (c) 2012 Soshen <nipponart.org>
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path	= (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx				= substr(strrchr (__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/functions_user.' . $phpEx);
include($phpbb_root_path . 'includes/functions_topicindex.' . $phpEx);

// Initilize the phpBB sessions.
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/lang_oindex');

// Start the output.
page_header($user->lang['OIINDEX_HEADER']);

// Check if the installation was finished
if (empty($config['otindex_version']))
{
	$redirect_url = append_sid("{$phpbb_root_path}index.{$phpEx}");
	meta_refresh(4, $redirect_url);
	trigger_error(sprintf($user->lang['OTINDEX_UMIL_NOT_ACTIVE'], '<a href="' . $redirect_url . '">', '</a>'));
}

// Now create the page
$list		= request_var('list', 0);
$iremove	= request_var('iremove', 0);
$ilimiter	= request_var('ilimit', '');
$list		= (int) $list;
$zurl		= append_sid("{$phpbb_root_path}topiclist.{$phpEx}", "list=" . $list);

// Action add / remove topics
if (!empty($iremove))
{
	// Get the relative forum
	$sql	= 'SELECT topic_id, forum_id FROM ' . TOPICS_TABLE . ' WHERE topic_id = ' . $iremove;
	$result	= $db->sql_query_limit($sql,1);
	$row	= $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	
	remove_from_ilist($row['forum_id'], $iremove);
	redirect($zurl, false, true);
}

// Navigation
$template->assign_block_vars('navlinks', array(
	'FORUM_NAME'	=> $user->lang['OIINDEX_HEADER'],
	'U_VIEW_FORUM'	=> $zurl
));

if (empty($list))
{
	// This is the main page
	
	// Grab crated list for select
	$s_list_options = '';
	$sql	= 'SELECT * FROM ' . TOPIC_LISTS . ' ORDER BY list_name ASC';
	$result	= $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($result))
	{		
		$s_list_options .= '<option value="' . $row['list_id'] . '">' . $row['list_name'] . '</option>';
	}
	$db->sql_freeresult($result);
	
	$template->assign_vars(array(
		'S_SHOWLIST'	 	=> false,
		'U_ACTION'			=> $zurl,
		'S_LIST_OPTIONS'	=> $s_list_options
	));
}
else
{
	// This is for the real list
	
	// Grab crated list for select
	$s_list_options = '';
	$sql	= 'SELECT * FROM ' . TOPIC_LISTS . ' ORDER BY list_name ASC';
	$result	= $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($result))
	{		
		$s_list_options .= '<option value="' . $row['list_id'] . '"' . (($list == $row['list_id']) ? ' selected="selected"' : '') . '>' . $row['list_name'] . '</option>';
	}
	$db->sql_freeresult($result);
	
	$template->assign_vars(array(
		'S_SHOWLIST'	 	=> true,
		'U_ACTION'			=> $zurl,
		'S_LIST_OPTIONS'	=> $s_list_options,
		'U_MCP'				=> ($auth->acl_getf_global('m_')) ? true : false
	));
	
	// Get relative list data
	$sql1 		= 'SELECT * FROM ' . TOPIC_LISTS . ' WHERE list_id = ' . $list;
	$result1	= $db->sql_query($sql1);
	$row1		= $db->sql_fetchrow($result1);
	$db->sql_freeresult($result1);
	
	$forumsari	= array();
	$forumsari 	= unserialize($row1['list_forum']);
	$filtrini	= range('a', 'z');
	$fixa		= array();
	$indexlist	= array();
	
	foreach ($forumsari as $forum_id)
	{
		$forum_id	= (int) $forum_id;
		$forum_data	= get_ForumBasedata($forum_id);
		
		$indexlist_temp	= get_topic_index($forum_id, 0, $forum_data['inindex'], $forum_data['filter']);
		$indexlist		= array_merge($indexlist, $indexlist_temp);
	}
	
	// Order the topics
	if (count($indexlist) > 0)
	{
		foreach ($indexlist as $key => $row)
		{
			$order_in_category[$key]  = $row['keybig'];
		}
		array_multisort($order_in_category, SORT_ASC, $indexlist);
	}
	
	$fixa 		= create_key_list($indexlist);
	$fixedlist	= filter_topiclist($indexlist, $ilimiter);
	$bulo		= (!$ilimiter) ? $fixa : array($ilimiter);
			
	// Create data for template
	foreach($filtrini AS $filtrino)
	{			
		// Build menù
		$template->assign_block_vars('block_filtrino', array(
			'U_FILTER'	=> append_sid("{$phpbb_root_path}topiclist.{$phpEx}", "list={$list}&amp;ilimit={$filtrino}"),
			'FILTRINO'	=> $filtrino,
			'S_ISWITH'	=> (in_array($filtrino, $fixa)) ? true : false
		));
	}
		
	// Build template data		
	foreach($fixa AS $realfilter)
	{
		$template->assign_block_vars('block_list', array(
			'FILTRINO'	=> ($realfilter == '_') ? $user->lang['SYMB'] : strtoupper($realfilter),
			'S_ISWITH2'	=> (in_array($realfilter, $bulo)) ? true : false
		));
		
		$nums = 0;
		foreach ($fixedlist AS $indexdata)
		{
			if ($realfilter == $indexdata['key'])
			{
				$template->assign_block_vars('block_list.block_topic_index', array(
					'ITOPIC_URL'	=> append_sid("{$phpbb_root_path}viewtopic.$phpEx", "f={$forum_id}&amp;t={$indexdata['id']}"),
					'ITOPIC_TITLE'	=> $indexdata['title'],
					'ITOPIC_POSTER'	=> get_username_string('full', $indexdata['posterid'], $indexdata['poster'], $indexdata['postercol']),
					'ITOPIC_TOTREP'	=> $indexdata['reply'],
					'U_REMOVE_FROM'	=> append_sid("{$phpbb_root_path}topiclist.{$phpEx}", "list={$list}&amp;iremove=" . $indexdata['id']),
					'ITOPIC_CLASS'	=> ($nums % 2) ? 'row bg1' : 'row bg2' 
				));
				$nums++;
			}
		}
	}
	
	// Others data for menu
	$template->assign_block_vars('block_nofiltrino', array(
		'U_TUTTI'	=> append_sid("{$phpbb_root_path}topiclist.{$phpEx}", "list={$list}"),
		'U_09'		=> append_sid("{$phpbb_root_path}topiclist.{$phpEx}", "list={$list}&amp;ilimit=09"),
		'U_SYMB'	=> append_sid("{$phpbb_root_path}topiclist.{$phpEx}", "list={$list}&amp;ilimit=_"),
		'S_09'		=> (in_array('09', $fixa)) ? true : false,
		'S_SYMB'	=> (in_array('_', $fixa)) ? true : false
	));
}

// Output the page
$template->set_filenames(array(
	'body' => 'topiclist.html')
);

page_footer();
?>